#ifndef __SEZNAM_H__
#define __SEZNAM_H__

#pragma once
#include <stdexcept>
#include <initializer_list>

using namespace std;

using T = int;
const T NULA = 0;

class seznam
{
	class prvek;
	prvek *hlava, *zarazka;
	mutable prvek *aktualni;
	void tunel(seznam &s);
public:
	seznam();
	seznam(const seznam &);
	seznam(seznam&&);
	seznam(initializer_list<T> seznamek);
	~seznam();
	seznam &operator=(const seznam &s);
	seznam &operator=(seznam &&s);
	seznam & seznam::operator+=(const seznam & s);
	seznam operator+(const seznam &s) const;
	void vyprazdni();
	bool prazdny() const;
	void vloz(T co);
	void vloz_na_konec(T co);
	bool najdi(T co) const;
	T &aktualni_hodnota();
	T seznam::aktualni_hodnota() const;
	bool dalsi() const;
	bool posledni() const;
	void reset() const;
	void na_konec() const;
};

class seznam::prvek
{
	T hodnota;
	prvek *_dalsi;
public:
	prvek(T hodnota, prvek *dalsi = nullptr)
		: hodnota(hodnota), _dalsi(dalsi)
	{}
	T &data();
	prvek *dalsi();
	void dalsi(prvek *dalsi);

};

#endif