#include <iostream>
#include <type_traits>
#include <initializer_list>
using namespace std;

#include "Seznam.h"

template<class T>
void vypis(seznam<T> &s)
{
	s.reset();
	if (!s.prazdny())
	{
		do
		{
			cout << s.aktualni_hodnota() << endl;
		} while (s.dalsi());
	}
}

template<class T>
void vlozeni(seznam<T>& s, T udaj)
{
	s.vloz_na_konec(udaj);
}

template<class T, class ... typy>
void vlozeni(seznam<T>& s, T udaj, typy... udaje)
{
	s.vloz_na_konec(udaj);
	vlozeni(s, udaje...);
}

template<typename ... typy>
auto vytvor_seznam(typy...data)
{
	using typ_slozek = common_type_t < typy... >;
	seznam<typ_slozek> s;
	vlozeni(s, (typ_slozek)data...);
	s.reset();
	return s;
}


using Seznam = seznam<int>;

int main()
{
	int i = 3;
	char c = 65;
	double x = 9.0;
	float y = 3.14f;
	auto www = vytvor_seznam(i, c, x, y);
	cout << www.aktualni_hodnota() << endl;
	Seznam s = { 6,7,8, };
	Seznam t = { 9, 10 };
	Seznam v = { 7,9 };
	cout << "----" << endl;
	Seznam u = s + t;
	cout << "----" << endl;
	v = s + t;
	cout << "----" << endl;
	vypis(u);
}