#include <algorithm>
#include <iostream>
#include "matice.h"

using namespace std;



matice::matice(double d)              // Konstruktor
	: p(new double[pocet][pocet])     // d je pocatecni hodnota
{                                     // diagonalnich prvku
									  // Pri neuspechu alokace vznikne vyjimka
	for (int i = 0; i < pocet; i++)
	{
		for (int j = 0; j < pocet; j++)
		{
			p[i][j] = 0;
		}
	}
	if (d)
	{
		for (int i = 0; i < pocet; i++) p[i][i] = d;
	}
}

matice::matice(const matice& m)       // Kopirovaci konstruktor
	: p(new double[pocet][pocet])
{
	memcpy(p, m.p, sizeof(double)*pocet*pocet);
	// Pri neuspechu alokace vznikne vyjimka
	/*for (int i = 0; i < pocet; i++)
	{
	for (int j = 0; j < pocet; j++)
	{
	p[i][j] = m.p[i][j];
	}
	}*/
}

matice::matice(matice &&m)
{
	p = m.p;
	m.p = nullptr;
}

matice matice::operator+(const matice& m) const
{
	matice vysledek(*this);                         // Lokalni kopie leveho operandu
	for (int i = 0; i < pocet; i++)
	{
		for (int j = 0; j < pocet; j++)
		{
			vysledek.p[i][j] += m.p[i][j];
		}
	}
	return vysledek;
}

matice operator*(const matice& m, const matice& n)
{
	matice vysledek;
	for (int i = 0; i < matice::pocet; i++)
	{
		for (int j = 0; j < matice::pocet; j++)
		{
			for (int k = 0; k < matice::pocet; k++)
			{
				vysledek.p[i][j] += m.p[i][k] * n.p[k][j];
			}
		}
	}
	return vysledek;
}

matice matice::operator*(const double d) const
{
	matice vysledek(*this);                         // Lokalni kopie leveho operandu
	for (int i = 0; i < pocet; i++)
	{
		for (int j = 0; j < pocet; j++)
		{
			vysledek.p[i][j] *= d;
		}
	}
	return vysledek;
}

double * matice::operator[](int i) const
{
	return p[i];
}

double& matice::prvek(int i, int j) const
{
	if ((i < 0) || (j < 0) || (i >= pocet) || (j >= pocet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];
}

double matice::operator()(int i, int j) const
{
	/*if ((i < 0) || (j < 0) || (i >= pocet) || (j >= pocet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];*/
	return prvek(i, j);
}

double& matice::operator()(int i, int j)
{
	/*if ((i < 0) || (j < 0) || (i >= pocet) || (j >= pocet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];*/
	return prvek(i, j);
}

matice matice::transpozice() const     // Operator transpozice
{
	matice vysledek(*this);                   // Pomocna instance - kopie operandu
	for (int i = 0; i < pocet; i++)
	{
		for (int j = i + 1; j < pocet; j++)
		{                              // Vlastni transposice
			swap(vysledek.p[i][j], vysledek.p[j][i]);
		}
	}
	return vysledek;                          // Vrati pomocnou instanci
}

matice& matice::operator=(const matice& m)
{
	for (int i = 0; i < pocet; i++)
	{
		for (int j = 0; j < pocet; j++)
		{
			p[i][j] = m.p[i][j];
		}
	}
	return *this;
}

matice & matice::operator=(matice && m)
{
	swap(p, m.p);
	return *this;
}

matice operator-(const matice& m)
{
	matice vysledek;
	for (int i = 0; i < matice::pocet; i++)
	{
		for (int j = 0; j < matice::pocet; j++)
		{
			vysledek.p[i][j] = -m.p[i][j];
		}
	}
	return vysledek;
}

matice::~matice()
{
	delete[] p;
}


void matice::vypis()
{
	for (int i = 0; i < pocet; i++)
	{
		for (int j = 0; j < pocet; j++)
		{
			cout << p[i][j] << " ";
		}
		cout << endl;
	}
}

auto_ptr_mat::auto_ptr_mat(matice* um)
	: vlastnik(true), pm(um)
{}

auto_ptr_mat::auto_ptr_mat(auto_ptr_mat &par)
{
	vlastnik = par.vlastnik;
	par.vlastnik = false;
	pm = par.pm;
}

matice *auto_ptr_mat::operator->()
{
	return pm;
}

auto_ptr_mat& auto_ptr_mat::operator=(auto_ptr_mat& par)
{
	if (vlastnik) delete pm;
	vlastnik = par.vlastnik;
	par.vlastnik = false;
	pm = par.pm;
	return *this;
}