#include <iostream>
#include <array>
using namespace std;

// Vytvoreni instance typu array<> ze zadanych parametru

template<typename... Ts>
constexpr auto vytvor_pole(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ ts... };
}

//Vytvoreni instance typu array<> z druhych mocnin zadanych parametru
// Prvni verze -- s pomocnou funkci sqr()

template<class T>
constexpr T kvadrat(T n)
{
	return n*n;
}

template<typename... Ts>
constexpr auto vytvor_pole_kvadratu(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ kvadrat(ts)... };
}

//Vytvoreni instance typu array<> z druhych mocnin zadanych parametru
// Druha verze -- bez pomocne funkce

template<typename... Ts>
constexpr auto vytvor_pole_kvadratu_2(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ (ts*ts)... };
}

int main()
{
	auto x = vytvor_pole(1.0, 3.0, 8.0);
	auto y = vytvor_pole_kvadratu(1.0, 3.0, 8.0);
	auto z = vytvor_pole_kvadratu_2(1.0, 3.0, 8.0);
}