#include <iostream>
#include <array>
#include <type_traits>

using namespace std;

// Genericky lambda-vyraz, operator() je sablona se dvema parametry
auto glambda = [](auto a, auto&& b) { return a < b; };
bool b = glambda(3, 3.14); // ok

// Genericky lambda-vyraz, operator() je sablona s jednim parametrem
auto vglambda = [](auto tisk) 
{
	return [=](auto&&... param) // Genericky lambda-vyraz, param je balik parametru
	{
		tisk(std::forward<decltype(param)>(param)...);
		return [=] { tisk(param...); }; // Lambda-vyraz bez parametru
	};
};

template<typename T1, typename T2>
auto Max2t(T1 a, T2 b)
{
	return a > b ? a : b;
}


template<typename T1, typename ... Typy>
decltype(auto) Max(T1 n, Typy...arg)
{
	auto pom = Max(arg...);
	return pom > n ? pom : n;
}

template<typename T1>
decltype(auto)  Max(T1 n)
{
	return n;
}

auto max_sqr = [](auto...param)
{
	return Max((param*param)...);
};


auto Maximum = [](const auto &a, const auto &b)	{return a > b ? a : b; };

int main()
{
	auto x = max_sqr(6.5f, -7l);
	x = Maximum(8.6, 9);
	auto p = vglambda([](auto v1, auto v2, auto v3) { std::cout << v1 << v2 << v3; });
	auto q = p(1, 'a', 3.14); // Vypise 1a3.14
	q();                      // Vypise 1a3.14
}
