#include <iostream>
using namespace std;

// Sablona c. 1 (primarni sablona)
template <typename T, int N>
class vektor {
	T p[N];
public:
	vektor(T t = 0)
	{
		for (int i = 0; i < N; i++)
		{
			p[i] = t;
		}
	}

	T& operator[](int i)
	{
		return p[i];
	}
	// ... a dalsi metody ...
};

template <typename T, int N>            // c. 2 (prvni specializace)
class vektor<T*, N> {
	T *p[N];
public:
	vektor(T t = 0)
	{
		for (int i = 0; i < N; i++)
		{
			p[i] = new T(t);
		}
	}

	T& operator[](int i)
	{
		return *p[i];
	}
};

template <typename T>                   // c. 3 (dalsi specializace)
class vektor<T*, 2>
{
	// ... slozky a metody ...
};

template<>
vektor<int, 2>::vektor(int i)           // c. 4 (jen konstruktor)
{
	cout << "Pozor: <int, 2>" << endl;
	// ... inicializace vektoru ...
}


int main()
{
	vektor<int, 10> vi;                     // Pouzije se sablona c. 1
	vektor<long*, 10> vlp;                  // Sablona c. 2, T == long
	vektor<double*, 2> vdp;                 // Sablona c. 3, T == double
	vektor<long*, 10> vld;
	vektor<int, 2> vi2;
}
