
// Priklad pouziti operatoru dynamic_cast

#include <iostream>
#include <stdlib.h>

using namespace std;

class Alfa {
	int i;
public:
	Alfa(int i) : i(i + 1) {}
	virtual void hlaseni() { cout << "Alfa" << endl; }
};
class Beta {
	int j;
public:
	Beta(int j) : j(j + 1) {}
	virtual void hlaseni() { cout << "Beta" << endl; }
	void SpecialniMetoda() {}
};

class Gama : public Alfa, public Beta {
public:											// Spolecny potomek Alfa a Beta
	Gama(int i) : Alfa(10 * i), Beta(i) {}
	virtual void hlaseni() { cout << "Gama" << endl; }
	void NejakaMetoda() {}
};

Alfa A(5), *uA = &A; 	// Instance a ukazatele na ne
Beta B(6), *uB = &B;
Gama G(8), *uG = &G;

void F(Alfa& a)
{
	try
	{
		dynamic_cast<Beta&>(a).SpecialniMetoda();
	}
	catch (bad_cast)
	{
		cout << "Promin, nejde to..." << endl;
	}
}

int main()
{
	system("CHCP 1250 > NUL");
	Gama *g = dynamic_cast<Gama*>(uB);	// Pretypovani
	if (g) g->NejakaMetoda();		// Test, zda se podarilo
	F(G);
	F(A);

	uB = &G;
	cout << static_cast<void*>(uB) << endl;	// Vypise ruzne vysledky
	cout << dynamic_cast<void*>(uB) << endl;
	return 0;
}
