#include <iostream>
#include <type_traits>
#include <initializer_list>
using namespace std;

#include "Seznam.h"

template<class T>
void vypi(seznam<T> &s)
{
	s.reset();
	if (!s.przdn())
	{
		do
		{
			cout << s.aktuln_hodnota() << endl;
		} while (s.dal());
	}
}

template<class T>
void vloen(seznam<T>& s, T daj)
{
	s.vlo_na_konec(daj);
}

template<class T, class ... typy>
void vloen(seznam<T>& s, T daj, typy... daje)
{
	s.vlo_na_konec(daj);
	vloen(s, daje...);
}

template<typename ... typy>
auto vytvo_seznam(typy...data)
{
	using typ_sloek = common_type_t < typy... >;
	seznam<typ_sloek> s;
	vloen(s, (typ_sloek)data...);
	s.reset();
	return s;
}


using Seznam = seznam<int>;

int main()
{
	int i = 3;
	char c = 65;
	double x = 9.0;
	float y = 3.14f;
	auto www = vytvo_seznam(i, c, x, y);
	cout << www.aktuln_hodnota() << endl;
	Seznam s = { 6,7,8, };
	Seznam t = { 9, 10 };
	Seznam v = { 7,9 };
	cout << "----" << endl;
	Seznam u = s + t;
	cout << "----" << endl;
	v = s + t;
	cout << "----" << endl;
	vypi(u);
}