#include <algorithm>
#include <iostream>
#include "matice.h"

using namespace std;



matice::matice(double d)              // Konstruktor
	: p(new double[poet][poet])     // d je poten hodnota
{                                     // diagonlnch prvk
									  // Pi nespchu alokace vznikne vjimka
	for (int i = 0; i < poet; i++)
	{
		for (int j = 0; j < poet; j++)
		{
			p[i][j] = 0;
		}
	}
	if (d)
	{
		for (int i = 0; i < poet; i++) p[i][i] = d;
	}
}

matice::matice(const matice& m)       // Koprovac konstruktor
	: p(new double[poet][poet])
{
	memcpy(p, m.p, sizeof(double)*poet*poet);
	// Pi nespchu alokace vznikne vjimka
	/*for (int i = 0; i < poet; i++)
	{
	for (int j = 0; j < poet; j++)
	{
	p[i][j] = m.p[i][j];
	}
	}*/
}

matice::matice(matice &&m)
{
	p = m.p;
	m.p = nullptr;
}

matice matice::operator+(const matice& m) const
{
	matice vsledek(*this);                         // Lokln kopie levho operandu
	for (int i = 0; i < poet; i++)
	{
		for (int j = 0; j < poet; j++)
		{
			vsledek.p[i][j] += m.p[i][j];
		}
	}
	return vsledek;
}

matice operator*(const matice& m, const matice& n)
{
	matice vsledek;
	for (int i = 0; i < matice::poet; i++)
	{
		for (int j = 0; j < matice::poet; j++)
		{
			for (int k = 0; k < matice::poet; k++)
			{
				vsledek.p[i][j] += m.p[i][k] * n.p[k][j];
			}
		}
	}
	return vsledek;
}

matice matice::operator*(const double d) const
{
	matice vsledek(*this);                         // Lokln kopie levho operandu
	for (int i = 0; i < poet; i++)
	{
		for (int j = 0; j < poet; j++)
		{
			vsledek.p[i][j] *= d;
		}
	}
	return vsledek;
}

double * matice::operator[](int i) const
{
	return p[i];
}

double& matice::prvek(int i, int j) const
{
	if ((i < 0) || (j < 0) || (i >= poet) || (j >= poet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];
}

double matice::operator()(int i, int j) const
{
	/*if ((i < 0) || (j < 0) || (i >= poet) || (j >= poet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];*/
	return prvek(i, j);
}

double& matice::operator()(int i, int j)
{
	/*if ((i < 0) || (j < 0) || (i >= poet) || (j >= poet))
	{
		throw out_of_range("index mimo meze");
	}
	return p[i][j];*/
	return prvek(i, j);
}

matice matice::transpozice() const     // Opertor transpozice
{
	matice vsledek(*this);                   // Pomocn instance - kopie operandu
	for (int i = 0; i < poet; i++)
	{
		for (int j = i + 1; j < poet; j++)
		{                              // Vlastn transposice
			swap(vsledek.p[i][j], vsledek.p[j][i]);
		}
	}
	return vsledek;                          // Vrt pomocnou instanci
}

matice& matice::operator=(const matice& m)
{
	for (int i = 0; i < poet; i++)
	{
		for (int j = 0; j < poet; j++)
		{
			p[i][j] = m.p[i][j];
		}
	}
	return *this;
}

matice & matice::operator=(matice && m)
{
	swap(p, m.p);
	return *this;
}

matice operator-(const matice& m)
{
	matice vsledek;
	for (int i = 0; i < matice::poet; i++)
	{
		for (int j = 0; j < matice::poet; j++)
		{
			vsledek.p[i][j] = -m.p[i][j];
		}
	}
	return vsledek;
}

matice::~matice()
{
	delete[] p;
}


void matice::vpis()
{
	for (int i = 0; i < poet; i++)
	{
		for (int j = 0; j < poet; j++)
		{
			cout << p[i][j] << " ";
		}
		cout << endl;
	}
}

auto_ptr_mat::auto_ptr_mat(matice* um)
	: vlastnk(true), pm(um)
{}

auto_ptr_mat::auto_ptr_mat(auto_ptr_mat &par)
{
	vlastnk = par.vlastnk;
	par.vlastnk = false;
	pm = par.pm;
}

matice *auto_ptr_mat::operator->()
{
	return pm;
}

auto_ptr_mat& auto_ptr_mat::operator=(auto_ptr_mat& par)
{
	if (vlastnk) delete pm;
	vlastnk = par.vlastnk;
	par.vlastnk = false;
	pm = par.pm;
	return *this;
}