#include <iostream>
#include <array>
using namespace std;

// Vytvoen instance typu array<> ze zadanch parametr

template<typename... Ts>
constexpr auto vytvo_pole(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ ts... };
}

//Vytvoen instance typu array<> z druhch mocnin zadanch parametr
// Prvn verze -- s pomocnou funkc sqr()

template<class T>
constexpr T kvadrt(T n)
{
	return n*n;
}

template<typename... Ts>
constexpr auto vytvo_pole_kvadrt(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ kvadrt(ts)... };
}

//Vytvoen instance typu array<> z druhch mocnin zadanch parametr
// Druh verze -- bez pomocn funkce

template<typename... Ts>
constexpr auto vytvo_pole_kvadrt_2(Ts&&... ts) ->
std::array<std::common_type_t<Ts...>, sizeof...(ts)>
{
	return{ (ts*ts)... };
}

int main()
{
	auto x = vytvo_pole(1.0, 3.0, 8.0);
	auto y = vytvo_pole_kvadrt(1.0, 3.0, 8.0);
	auto z = vytvo_pole_kvadrt_2(1.0, 3.0, 8.0);
}