#ifndef __SEZNAM_H__
#define __SEZNAM_H__

#pragma once
#include <stdexcept>
#include <initializer_list>

using namespace std;

using T = int;
const T NULA = 0;

class seznam
{
	class prvek;
	prvek *hlava, *zarka;
	mutable prvek *aktuln;
	void tunel(seznam &s);
public:
	seznam();
	seznam(const seznam &);
	seznam(seznam&&);
	seznam(initializer_list<T> seznmek);
	~seznam();
	seznam &operator=(const seznam &s);
	seznam &operator=(seznam &&s);
	seznam & seznam::operator+=(const seznam & s);
	seznam operator+(const seznam &s) const;
	void vyprzdni();
	bool przdn() const;
	void vlo(T co);
	void vlo_na_konec(T co);
	bool najdi(T co) const;
	T &aktuln_hodnota();
	T seznam::aktuln_hodnota() const;
	bool dal() const;
	bool posledn() const;
	void reset() const;
	void na_konec() const;
};

class seznam::prvek
{
	T hodnota;
	prvek *_dal;
public:
	prvek(T hodnota, prvek *dal = nullptr)
		: hodnota(hodnota), _dal(dal)
	{}
	T &data();
	prvek *dal();
	void dal(prvek *dal);

};

#endif