#include <iostream>
#include <stdexcept>
#include <exception>
#include <string>
#include <fstream>

// prints the explanatory string of an exception. If the exception is nested,
// recurses to print the explanatory of the exception it holds
void vypi_vjimku(const std::exception& e, int level = 0)
{
	//std::cerr << typeid(e).name() << std::endl;
	std::cerr << std::string(level, ' ') << "vjimka: " << e.what() << '\n';
	try {
		std::rethrow_if_nested(e);
	}
	catch (const std::exception& e) {
		vypi_vjimku(e, level + 1);
	}
	catch (...) {}
}

void otevi_soubor(const std::string& jmno)
{
	try {
		std::ifstream soubor(jmno);
		soubor.exceptions(std::ios_base::failbit);
	}
	catch (...) {
		std::throw_with_nested(std::runtime_error("Nepodailo se otevt soubor " + jmno));
	}
}

void zpracuj()
{
	try {
		otevi_soubor("neexistuje.txt");
	}
	catch (...) {
		std::throw_with_nested(std::runtime_error("voln zpracuj() neusplo"));
	}
}

int main()
{
	try {
		zpracuj();
	}
	catch (const std::exception& e) {
		vypi_vjimku(e);
	}
}